<?php
class ControllerExtensionModuleAdmin extends Controller {
    private $error = array();  
    public function index() {   
	
		$language = $this->load->language('extension/module/admin');
        $data = array_merge($language);

        $this->document->setTitle($this->language->get('heading_title'));
		$this->document->addStyle('view/colorpicker/css/colorpicker.css');
  		$this->document->addScript('view/colorpicker/js/colorpicker.js');
		$this->document->addStyle('view/stylesheet/codemirror/lib/codemirror.css?');
        $this->document->addStyle('view/stylesheet/codemirror/mode/theme/monokai.css?');
        $this->document->addScript('view/javascript/codemirror/lib/codemirror.js');
        $this->document->addScript('view/javascript/codemirror/mode/css/css.js');
        $this->document->addScript('view/javascript/codemirror/mode/javascript/javascript.js');
        
        $this->load->model('setting/setting');
        
        $this->load->model('tool/image');  
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('admin', $this->request->post);    

            $this->session->data['success'] = $this->language->get('text_success');
        
            if(isset($this->request->post['save_stay']) and $this->request->post['save_stay']=1)
			$this->response->redirect($this->url->link('extension/module/admin', 'user_token=' . $this->session->data['user_token'], true));
			else
			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
        }
		
            $data['text_image_manager'] = 'Image manager';
            $data['user_token'] = $this->session->data['user_token'];       
       
		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

        $config_data = array(
        'admin_header_status',
		'admin_img1',
		'admin_img2',
		'admin_header_text1',
		'admin_header_text2',
		'admin_header_text3',			
		'admin_color_main',
		'admin_second_color',
		'admin_text_color',
		'admin_third_color',
		'admin_name_color',
		'admin_font',
		'admin_custom_css',
		);
       foreach ($config_data as $conf) {
            if (isset($this->request->post[$conf])) {
                $data[$conf] = $this->request->post[$conf];
            } else {
                $data[$conf] = $this->config->get($conf);
            }
        }		
		
		if (isset($this->request->post['admin_header_status'])) {
			$data['admin_header_status'] = $this->request->post['admin_header_status'];
		} elseif ($this->config->get('admin_header_status')) {
			$data['admin_header_status'] = $this->config->get('admin_header_status');
		} else {
			$data['admin_header_status'] = 0;
		}
		
		if (isset($this->request->post['admin_color_main'])) {
			$data['admin_color_main'] = $this->request->post['admin_color_main'];
		} elseif (!empty($module_info)) {
			$data['admin_color_main'] = $module_info['admin_color_main'];
		} else {
			$data['admin_color_main'] = '';
		}
		if (isset($this->request->post['admin_second_color'])) {
			$data['admin_second_color'] = $this->request->post['admin_second_color'];
		} elseif (!empty($module_info)) {
			$data['admin_second_color'] = $module_info['admin_second_color'];
		} else {
			$data['admin_second_color'] = '';
		}
       if (isset($this->request->post['admin_text_color'])) {
			$data['admin_text_color'] = $this->request->post['admin_text_color'];
		} elseif (!empty($module_info)) {
			$data['admin_text_color'] = $module_info['admin_text_color'];
		} else {
			$data['admin_text_color'] = '';
		}
		if (isset($this->request->post['admin_third_color'])) {
			$data['admin_third_color'] = $this->request->post['admin_third_color'];
		} elseif (!empty($module_info)) {
			$data['admin_third_color'] = $module_info['admin_third_color'];
		} else {
			$data['admin_third_color'] = '';
		}
		 if (isset($this->request->post['admin_name_color'])) {
			$data['admin_name_color'] = $this->request->post['admin_name_color'];
		} elseif (!empty($module_info)) {
			$data['admin_name_color'] = $module_info['admin_name_color'];
		} else {
			$data['admin_name_color'] = '';
		}
	  	if (isset($this->request->post['admin_img1']) && is_file(DIR_IMAGE . $this->request->post['admin_img1'])) {
			$data['admin_img1_preview'] = $this->model_tool_image->resize($this->request->post['admin_img1'], 100, 100);
		} elseif ($this->config->get('admin_img1') && is_file(DIR_IMAGE . $this->config->get('admin_img1'))) {
			$data['admin_img1_preview'] = $this->model_tool_image->resize($this->config->get('admin_img1'), 100, 100);
		} else {
			$data['admin_img1_preview'] = $this->model_tool_image->resize('no_image.png', 100, 100);;
		}
		if (isset($this->request->post['admin_img2']) && is_file(DIR_IMAGE . $this->request->post['admin_img2'])) {
			$data['admin_img2_preview'] = $this->model_tool_image->resize($this->request->post['admin_img2'], 100, 100);
		} elseif ($this->config->get('admin_img2') && is_file(DIR_IMAGE . $this->config->get('admin_img2'))) {
			$data['admin_img2_preview'] = $this->model_tool_image->resize($this->config->get('admin_img2'), 100, 100);
		} else {
			$data['admin_img2_preview'] = $this->model_tool_image->resize('no_image.png', 100, 100);;
		}
	  
        foreach ($config_data as $conf) {
            if (isset($this->request->post[$conf])) {
                $data[$conf] = $this->request->post[$conf];
            } else {
                $data[$conf] = $this->config->get($conf);
            }
        }
    
        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }
        
        $data['breadcrumbs'] = array();
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);
        
        $data['breadcrumbs'][] = array(
            'text'      => $this->language->get('heading_title'),
            'href'      => $this->url->link('extension/module/admin', 'user_token=' . $this->session->data['user_token'], true)
        );
		
		$data['action'] = $this->url->link('extension/module/admin', 'user_token=' . $this->session->data['user_token'], true);
		
		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);
    
        if (isset($this->request->post['admin_module'])) {
            $modules = explode(',', $this->request->post['admin_module']);
        } elseif ($this->config->get('admin_module') != '') {
            $modules = explode(',', $this->config->get('admin_module'));
        } else {
            $modules = array();
        }           
                
		$this->load->model('localisation/language');
		
		$data['languages'] = $this->model_localisation_language->getLanguages();

        $data['modules'] = $modules;
        
        if (isset($this->request->post['admin_module'])) {
            $data['admin_module'] = $this->request->post['admin_module'];
        } else {
            $data['admin_module'] = $this->config->get('admin_module');

		}
		
		$data['admin_modules'] = array();
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/admin', $data));

    }
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/admin')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	public function uninstall() {
      $this->load->model('setting/setting');
      $this->model_setting_setting->deleteSetting('admin');

}
}